package com.maroontress.sanctuary;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import java.io.PrintWriter;

/**
   ѥɤμǤ
*/
public abstract class CompoundImpl implements Compound {

    /** 롼 */
    private Group group;

    /** "struct" ޤ "union" ޤ "eunm" */
    private String label;

    /** ѥɤĥݡͥȤΥå */
    private Components components;

    /** descǤ */
    private Description desc;

    /** ɥȤ˵ܤ뤳η̾ */
    private Strings descType;

    /**
       ѥɤޤ

       @param g 饹
       @param label "struct" ޤ "union" ޤ "enum"
       @param elem struct(member)Ǥޤunion(member)Ǥޤ
       enum(member)
       @param descType ɥȤ˵ܤ뤳η̾
    */
    protected CompoundImpl(final Class g, final String label,
			   final Element elem, final Strings descType) {
	group = g;
	this.label = label;
	this.descType = descType;

	ChildrenFilter c = new ChildrenFilter(elem);
	NodeList nodes = c.getDirectChildrenByTagName(getTagName());
	desc = getDescription(c);
	components = getComponents(g, descType, nodes);
    }

    /**
       ݡͥȤΥ̾ޤ

       @return ݡͥȤΥ̾
    */
    protected abstract String getTagName();

    /**
       ѥɤޤ

       @param c ȤʤǤλҥΡɥե륿
       @return ѥɤ
    */
    protected abstract Description getDescription(final ChildrenFilter c);

    /**
       ΡɥꥹȤ饳ݡͥȤΥåȤޤ

       @param g 饹
       @param descType ɥȤ˵ܤ뤳η̾
       @param nodes ݡͥȤΥΡɥꥹ
       @return ݡͥȤΥå
    */
    protected abstract Components getComponents(Class g,
						Strings descType,
						NodeList nodes);

    /**
       롼פޤ

       @return 롼
    */
    protected final Group getGroup() {
	return group;
    }

    /**
       ѥɤμޤ

       @return "struct" ޤ "union" ޤ "eunm"
    */
    protected final String getLabel() {
	return label;
    }

    /**
       Υѥɤ˽°륳ݡͥȤΥåȤޤ

       @return ݡͥȤΥå
    */
    protected final Components getComponents() {
	return components;
    }

    /**
       HTML˽Ϥե̾ޤ

       @return ե̾
    */
    protected String getSummaryName() {
	return "<b>" + group.getHTML(descType.getQualified()) + "</b>";
    }

    /**
       HTMLξܺ٤˽Ϥե̾ޤ

       @return ե̾
    */
    protected String getDetailName() {
	return "<b>" + descType.getSimple() + "</b>";
    }

    /**
       TeXξܺ٤˽Ϥե̾ޤ

       @return ե̾
    */
    protected String getTexDetailName() {
	return descType.getSimple();
    }

    public final void printCompoundSummary(final PrintWriter wr) {
	String fieldName = getSummaryName();

	wr.println(""
+ "    <table width=\"100%\" cellspacing=\"0\" border=\"1\">\n"
+ "      <tr>\n"
+ "        <td colspan=\"2\"><font size=\"+1\">" + fieldName + "</font><br>\n"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "        </tr>\n"
+ "      <tr>\n");
	components.printSummary(wr);
	wr.println(""
+ "      </tr>\n"
+ "    </table><br>");
    }

    public final void printCompoundDetail(final PrintWriter wr) {
	String fieldName = getDetailName();

	wr.println(""
+ "<p><a name=\"" + descType + "\"></a>\n"
+ "<font size=\"+1\">" + fieldName + "</font></p>\n"
+ "<dl><dd>" + desc.getText());
	components.printDetail(wr);
	wr.println(""
+ "</dd></dl>\n"
+ "<hr>");
    }

    public final void printTexCompoundDetail(final PrintWriter wr) {
	String fieldName = Tex.safe(getTexDetailName());

	wr.println("\\Sid{" + fieldName + "}");
	wr.println(desc.getTexText());

	components.printTexDetail(wr);
    }
}
